TCHAR *DirectDrawErrorCode(HRESULT result) {
	switch(result) {
		case E_FAIL:				return _T("E_FAIL");
		case E_NOINTERFACE:			return _T("E_NOINTERFACE");
		case E_OUTOFMEMORY:			return _T("E_OUTOFMEMORY");
		case E_INVALIDARG:			return _T("E_INVALIDARG");
		case E_NOTIMPL:				return _T("E_NOTIMPL");
		case DDERR_ALREADYINITIALIZED:		return _T("DDERR_CANNOTATTACHSURFACE");
		case DDERR_CANNOTATTACHSURFACE:		return _T("DDERR_CANNOTDETACHSURFACE");
		case DDERR_CURRENTLYNOTAVAIL:		return _T("DDERR_CURRENTLYNOTAVAIL");
		case DDERR_EXCEPTION:			return _T("DDERR_EXCEPTION");
		//case DDERR_GENERIC:			return _T("DDERR_GENERIC");
		case DDERR_HEIGHTALIGN:			return _T("DDERR_HEIGHTALIGN");
		case DDERR_INCOMPATIBLEPRIMARY:		return _T("DDERR_INCOMPATIBLEPRIMARY");
		case DDERR_INVALIDCAPS:			return _T("DDERR_INVALIDCAPS");
		case DDERR_INVALIDCLIPLIST:		return _T("DDERR_INVALIDCLIPLIST");
		case DDERR_INVALIDMODE:			return _T("DDERR_INVALIDMODE");
		case DDERR_INVALIDOBJECT:		return _T("DDERR_INVALIDOBJECT");
		//case DDERR_INVALIDPARAMS:		return _T("DDERR_INVALIDPARAMS");
		case DDERR_INVALIDPIXELFORMAT:		return _T("DDERR_INVALIDPIXELFORMAT");
		case DDERR_INVALIDRECT:			return _T("DDERR_INVALIDRECT");
		case DDERR_LOCKEDSURFACES:		return _T("DDERR_LOCKEDSURFACES");
		case DDERR_NO3D:			return _T("DDERR_NO3D");
		case DDERR_NOALPHAHW:			return _T("DDERR_NOALPHAHW");
		case DDERR_NOCLIPLIST:	                return _T("DDERR_NOCLIPLIST");
		case DDERR_NOCOLORCONVHW:	        return _T("DDERR_NOCOLORCONVHW");
		case DDERR_NOCOOPERATIVELEVELSET:	return _T("DDERR_NOCOOPERATIVELEVELSET");
		case DDERR_NOCOLORKEY:	                return _T("DDERR_NOCOLORKEY");
		case DDERR_NOCOLORKEYHW:	        return _T("DDERR_NOCOLORKEYHW");
		case DDERR_NODIRECTDRAWSUPPORT:	        return _T("DDERR_NODIRECTDRAWSUPPORT");
		case DDERR_NOEXCLUSIVEMODE:	        return _T("DDERR_NOEXCLUSIVEMODE");
		case DDERR_NOFLIPHW:	                return _T("DDERR_NOFLIPHW");
		case DDERR_NOGDI:	                return _T("DDERR_NOGDI");
		case DDERR_NOMIRRORHW:	                return _T("DDERR_NOMIRRORHW");
		case DDERR_NOTFOUND:	                return _T("DDERR_NOTFOUND");
		case DDERR_NOOVERLAYHW:	                return _T("DDERR_NOOVERLAYHW");
		case DDERR_OVERLAPPINGRECTS:	        return _T("DDERR_OVERLAPPINGRECTS");
		case DDERR_NORASTEROPHW:	        return _T("DDERR_NORASTEROPHW");
		case DDERR_NOROTATIONHW:	        return _T("DDERR_NOROTATIONHW");
		case DDERR_NOSTRETCHHW:	                return _T("DDERR_NOSTRETCHHW");
		case DDERR_NOT4BITCOLOR:	        return _T("DDERR_NOT4BITCOLOR");
		case DDERR_NOT4BITCOLORINDEX:	        return _T("DDERR_NOT4BITCOLORINDEX");
		case DDERR_NOT8BITCOLOR:	        return _T("DDERR_NOT8BITCOLOR");
		case DDERR_NOTEXTUREHW:	                return _T("DDERR_NOTEXTUREHW");
		case DDERR_NOVSYNCHW:			return _T("DDERR_NOVSYNCHW");
		case DDERR_NOZBUFFERHW:	                return _T("DDERR_NOZBUFFERHW");
		case DDERR_NOZOVERLAYHW:	        return _T("DDERR_NOZOVERLAYHW");
		case DDERR_OUTOFCAPS:	                return _T("DDERR_OUTOFCAPS");
		//case DDERR_OUTOFMEMORY:	                return _T("DDERR_OUTOFMEMORY");
		case DDERR_OUTOFVIDEOMEMORY:	        return _T("DDERR_OUTOFVIDEOMEMORY");
		case DDERR_OVERLAYCANTCLIP:	        return _T("DDERR_OVERLAYCANTCLIP");
		case DDERR_OVERLAYCOLORKEYONLYONEACTIVE:return _T("DDERR_OVERLAYCOLORKEYONLYONEACTIVE");
		case DDERR_PALETTEBUSY:	                return _T("DDERR_PALETTEBUSY");
		case DDERR_COLORKEYNOTSET:	        return _T("DDERR_COLORKEYNOTSET");
		case DDERR_SURFACEALREADYATTACHED:	return _T("DDERR_SURFACEALREADYATTACHED");
		case DDERR_SURFACEALREADYDEPENDENT:	return _T("DDERR_SURFACEALREADYDEPENDENT");
		case DDERR_SURFACEBUSY:	                return _T("DDERR_SURFACEBUSY");
		case DDERR_CANTLOCKSURFACE:	        return _T("DDERR_CANTLOCKSURFACE");
		case DDERR_SURFACEISOBSCURED:	        return _T("DDERR_SURFACEISOBSCURED");
		case DDERR_SURFACELOST:	                return _T("DDERR_SURFACELOST");
		case DDERR_SURFACENOTATTACHED:	        return _T("DDERR_SURFACENOTATTACHED");
		case DDERR_TOOBIGHEIGHT:	        return _T("DDERR_TOOBIGHEIGHT");
		case DDERR_TOOBIGSIZE:	                return _T("DDERR_TOOBIGSIZE");
		case DDERR_TOOBIGWIDTH:	                return _T("DDERR_TOOBIGWIDTH");
		//case DDERR_UNSUPPORTED:	                return _T("DDERR_UNSUPPORTED");
		case DDERR_UNSUPPORTEDFORMAT:	        return _T("DDERR_UNSUPPORTEDFORMAT");
		case DDERR_UNSUPPORTEDMASK:	        return _T("DDERR_UNSUPPORTEDMASK");
		case DDERR_INVALIDSTREAM:	        return _T("DDERR_INVALIDSTREAM");
		case DDERR_VERTICALBLANKINPROGRESS:	return _T("DDERR_VERTICALBLANKINPROGRESS");
		case DDERR_WASSTILLDRAWING:	        return _T("DDERR_WASSTILLDRAWING");
		case DDERR_XALIGN:	                return _T("DDERR_XALIGN");
		case DDERR_INVALIDDIRECTDRAWGUID:	return _T("DDERR_INVALIDDIRECTDRAWGUID");
		case DDERR_DIRECTDRAWALREADYCREATED:	return _T("DDERR_DIRECTDRAWALREADYCREATED");
		case DDERR_NODIRECTDRAWHW:	        return _T("DDERR_NODIRECTDRAWHW");
		case DDERR_PRIMARYSURFACEALREADYEXISTS:	return _T("DDERR_PRIMARYSURFACEALREADYEXISTS");
		case DDERR_NOEMULATION:	                return _T("DDERR_NOEMULATION");
		case DDERR_REGIONTOOSMALL:	        return _T("DDERR_REGIONTOOSMALL");
		case DDERR_CLIPPERISUSINGHWND:	        return _T("DDERR_CLIPPERISUSINGHWND");
		case DDERR_NOCLIPPERATTACHED:	        return _T("DDERR_NOCLIPPERATTACHED");
		case DDERR_NOHWND:	                return _T("DDERR_NOHWND");
		case DDERR_HWNDSUBCLASSED:	        return _T("DDERR_HWNDSUBCLASSED");
		case DDERR_HWNDALREADYSET:	        return _T("DDERR_HWNDALREADYSET");
		case DDERR_NOPALETTEATTACHED:	        return _T("DDERR_NOPALETTEATTACHED");
		case DDERR_NOPALETTEHW:	                return _T("DDERR_NOPALETTEHW");
		case DDERR_BLTFASTCANTCLIP:	        return _T("DDERR_BLTFASTCANTCLIP");
		case DDERR_NOBLTHW:	                return _T("DDERR_NOBLTHW");
		case DDERR_NODDROPSHW:	                return _T("DDERR_NODDROPSHW");
		case DDERR_OVERLAYNOTVISIBLE:	        return _T("DDERR_OVERLAYNOTVISIBLE");
		case DDERR_NOOVERLAYDEST:	        return _T("DDERR_NOOVERLAYDEST");
		case DDERR_INVALIDPOSITION:	        return _T("DDERR_INVALIDPOSITION");
		case DDERR_NOTAOVERLAYSURFACE:	        return _T("DDERR_NOTAOVERLAYSURFACE");
		case DDERR_EXCLUSIVEMODEALREADYSET:	return _T("DDERR_EXCLUSIVEMODEALREADYSET");
		case DDERR_NOTFLIPPABLE:	        return _T("DDERR_NOTFLIPPABLE");
		case DDERR_CANTDUPLICATE:	        return _T("DDERR_CANTDUPLICATE");
		case DDERR_NOTLOCKED:	                return _T("DDERR_NOTLOCKED");
		case DDERR_CANTCREATEDC:	        return _T("DDERR_CANTCREATEDC");
		case DDERR_NODC:	                return _T("DDERR_NODC");
		case DDERR_WRONGMODE:	                return _T("DDERR_WRONGMODE");
		case DDERR_IMPLICITLYCREATED:	        return _T("DDERR_IMPLICITLYCREATED");
		case DDERR_NOTPALETTIZED:	        return _T("DDERR_NOTPALETTIZED");
		case DDERR_UNSUPPORTEDMODE:	        return _T("DDERR_UNSUPPORTEDMODE");
		case DDERR_NOMIPMAPHW:	                return _T("DDERR_NOMIPMAPHW");
		case DDERR_INVALIDSURFACETYPE:	        return _T("DDERR_INVALIDSURFACETYPE");
		case DDERR_NOOPTIMIZEHW:	        return _T("DDERR_NOOPTIMIZEHW");
		case DDERR_NOTLOADED:	                return _T("DDERR_NOTLOADED");
		case DDERR_NOFOCUSWINDOW:	        return _T("DDERR_NOFOCUSWINDOW");
		case DDERR_DCALREADYCREATED:	        return _T("DDERR_DCALREADYCREATED");
		case DDERR_NONONLOCALVIDMEM:	        return _T("DDERR_NONONLOCALVIDMEM");
		case DDERR_CANTPAGELOCK:	        return _T("DDERR_CANTPAGELOCK");
		case DDERR_CANTPAGEUNLOCK:	        return _T("DDERR_CANTPAGEUNLOCK");
		case DDERR_NOTPAGELOCKED:	        return _T("DDERR_NOTPAGELOCKED");
		case DDERR_MOREDATA:	                return _T("DDERR_MOREDATA");
		case DDERR_EXPIRED:	                return _T("DDERR_EXPIRED");
		case DDERR_VIDEONOTACTIVE:	        return _T("DDERR_VIDEONOTACTIVE");
		case DDERR_DEVICEDOESNTOWNSURFACE:	return _T("DDERR_DEVICEDOESNTOWNSURFACE");
		case DDERR_NOTINITIALIZED:              return _T("DDERR_NOTINITIALIZED");
		default:				return _T("Unknown error");
	}
};