#include	"..\..\DLL\d_iNES.h"
#include	"..\..\Hardware\h_MMC3.h"
#include	"mapper004-T9552.h"

namespace {
void	sync (void) {
	MMC3::syncWRAM();

	MMC3::syncPRG(0xFF, 0x00); // Should be 0x3F if we were really strict.
	MMC3::syncCHR(0xFF, 0x00);
	
	if (ROM->INES2_SubMapper ==2) // TFROM with fixed mirroring.
		iNES_SetMirroring();
	else
	if (ROM->INES_Flags &8)
		EMU->Mirror_4();
	else
		MMC3::syncMirror();
}

BOOL	MAPINT	load (void) {
	iNES_SetSRAM();
	// Determine ASIC-specific PPU cycle handler
	switch (ROM->INES2_SubMapper) {
		case 1:  MMC3::load(sync, MMC3Type::MMC6);      break;
		case 3:  MMC3::load(sync, MMC3Type::Acclaim);   break;
		case 4:  MMC3::load(sync, MMC3Type::NEC);       break;
		case 5:  MMC3::load(sync_T9552, MMC3Type::NEC); break;
		case 0:
		case 2:
		default: MMC3::load(sync, MMC3Type::Sharp);     break;
	}
	
	MapperInfo_004.Reset    =ROM->INES2_SubMapper ==5? reset_T9552: MMC3::reset;
	MapperInfo_004.SaveLoad =ROM->INES2_SubMapper ==5? saveLoad_T9552: MMC3::saveLoad;
	
	// Identify board name based on submapper and RAM/ROM sizes
	if (ROM->INES2_SubMapper ==1)
		MapperInfo_004.Description = _T("Nintendo HKROM");
	else
	if (ROM->INES2_SubMapper ==3) {
		MapperInfo_004.Description = _T("Acclaim MC-ACC");
	} else
	if (ROM->INES2_SubMapper ==5)
		MapperInfo_004.Description = _T("43-319");
	else
	if (ROM->INES_Flags &8) {
		if (ROM->INES_PRGSize <128/16)
			MapperInfo_004.Description = _T("Nintendo TVROM");
		else
			MapperInfo_004.Description = _T("Nintendo TR1ROM");
	} else
	if (ROM->INES_CHRSize ==0) {
		if (ROM->INES_Version >=2) {
			if (ROM->INES2_PRGRAM >0)
				MapperInfo_004.Description = _T("Nintendo TNROM");
			else
				MapperInfo_004.Description = _T("Nintendo TGROM");
		} else
			MapperInfo_004.Description = _T("Nintendo TGROM/TNROM");
	} else
	if (ROM->INES_PRGSize ==32/16) {
		MapperInfo_004.Description = _T("Nintendo TEROM");
	} else
	if (ROM->INES_PRGSize ==64/16) {
		MapperInfo_004.Description = _T("Nintendo TBROM");
	} else
	if (ROM->INES_CHRSize <128/8) {
		MapperInfo_004.Description = _T("Nintendo TFROM");
	} else
	if (ROM->INES_Version >=2) {
		if (ROM->INES2_PRGRAM >0) {
			if (ROM->INES_Flags &2)
				MapperInfo_004.Description = _T("Nintendo TKROM");
			else
				MapperInfo_004.Description = _T("Nintendo TKROM/TSROM");
		} else
			MapperInfo_004.Description = _T("Nintendo TLROM");
	} else
	if (ROM->INES_Flags &2)
		MapperInfo_004.Description = _T("Nintendo TKROM");
	else
		MapperInfo_004.Description = _T("Nintendo TKROM/TLROM/TSROM");
	
	if (ROM->PRGROMSize >524288) EMU->DbgOut(L"Warning: MMC3 with >512 KiB of PRG-ROM!");
	return TRUE;
}

uint16_t mapperNum004 =4;
uint16_t mapperNum249 =249;
} // namespace

MapperInfo MapperInfo_004 ={
	&mapperNum004,
	_T("Nintendo TxROM/HKROM"),
	COMPAT_FULL,
	load,
	MMC3::reset,
	NULL,
	MMC3::cpuCycle,
	MMC3::ppuCycle,
	MMC3::saveLoad,
	NULL,
	NULL
};

MapperInfo MapperInfo_249 ={
	&mapperNum249,
	_T("43-319"),
	COMPAT_FULL,
	load_T9552,
	reset_T9552,
	NULL,
	MMC3::cpuCycle,
	MMC3::ppuCycle,
	saveLoad_T9552,
	NULL,
	NULL
};
